package com.javacodegeeks;

import org.w3c.dom.Document;
import org.w3c.dom.NodeList;
import org.xml.sax.SAXException;

import javax.xml.parsers.DocumentBuilder;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.ParserConfigurationException;
import javax.xml.xpath.XPath;
import javax.xml.xpath.XPathConstants;
import javax.xml.xpath.XPathExpressionException;
import javax.xml.xpath.XPathFactory;
import java.io.IOException;

/**
 * Example code for XPath ancestor selection
 * @author Java Code Geeks
 */
public class ExampleXPathAncestor {

    private static DocumentBuilderFactory builderFactory = DocumentBuilderFactory.newInstance();
    private static DocumentBuilder builder = null;
    private static XPath xPath = null;
    private static Document document = null;

    public static void main(String q[]) {
        try {
            builder = builderFactory.newDocumentBuilder();
            document = builder.parse(ExampleXPathAncestor.class.getResourceAsStream("/user.xml"));
        } catch (ParserConfigurationException e) {
            e.printStackTrace();
        } catch (SAXException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
        xPath =  XPathFactory.newInstance().newXPath();
        String expression = "//SecondLineOfAddress/ancestor::Address";
        try {
            NodeList nl = (NodeList) xPath.compile(expression).evaluate(document, XPathConstants.NODESET);
            System.out.println(nl.getLength());
            System.out.println(nl.item(0).getTextContent());
            System.out.println(nl.item(1).getTextContent());
            System.out.println(nl.item(3).getTextContent());
        } catch (XPathExpressionException e) {
            e.printStackTrace();
        }

    }

}
